#import <Foundation/Foundation.h>
#import <string>
#import "process_info.h"
#import "hack_parser.h"
#import "code_inject.h"
#import <dlfcn.h>

#define RAW_ADDR(x) (((uintptr_t)x & 1) ? (uintptr_t)x & ~0x1 : (uintptr_t)x)

void apply_hack(hack *, NSDictionary*);

__attribute__((constructor))
void DYLIB_ENTRY(void)
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
     
    cpu_subtype_t type = get_current_cpu_subtype();
    
    NSDictionary *infoPlist = [[NSBundle mainBundle] infoDictionary];
    
    NSString *bundleID = [infoPlist objectForKey:@"CFBundleIdentifier"];
    NSString *shortVersion = [infoPlist objectForKey:@"CFBundleShortVersionString"];
    NSString *bundleVersion = [infoPlist objectForKey:@"CFBundleVersion"];

    NSString *prefs = [NSString stringWithFormat:@"/private/var/mobile/Library/iCheats/HackPreferences/%@.hackpref", bundleID];
    NSFileManager *manager = [NSFileManager defaultManager];

    NSDictionary *hack_prefs = nil;
    
    if([manager fileExistsAtPath:prefs])
    {
        //  load prefs
        hack_prefs = [NSDictionary dictionaryWithContentsOfFile:prefs];
    }
        
        uint16_t *test = reinterpret_cast<uint16_t*>(RAW_ADDR(NSLog));
        patch<uint16_t>(test, CFSwapInt16(0x7047));
    
    
    switch (type) {
        case CPU_SUBTYPE_ARM_V6:
        {
            NSString *filepath = [NSString stringWithFormat:@"/private/var/mobile/Library/iCheats/%@/%@|%@|v6.hack", bundleID, shortVersion, bundleVersion];
            if(![manager fileExistsAtPath:filepath])
            {
                NSLog(@"hack %@ not found", filepath);
                break;
            }
            hack *hackData = [[hack alloc] initWithHackFile:filepath];
            apply_hack(hackData, hack_prefs);
            [hackData release];
        }
            break;
        case CPU_SUBTYPE_ARM_V7:
        {
            NSString *filepath = [NSString stringWithFormat:@"/private/var/mobile/Library/iCheats/%@/%@|%@|v7.hack", bundleID, shortVersion, bundleVersion]; 
            if(![manager fileExistsAtPath:filepath])
            {
                NSLog(@"hack %@ not found", filepath);
                break;
            }
            hack *hackData = [[hack alloc] initWithHackFile:filepath];
            apply_hack(hackData, hack_prefs);
            [hackData release];
        }
            break;
        default:
        {
            NSLog(@"WTF ARE YOU RUNNING???");
        }
            break;
    }
    [pool drain];
}

#define HACK_ERR() \
NSLog(@"Patching failed: Name: %@ Address %@ data %@", name, address, data)

void apply_hack(hack *hackData, NSDictionary* prefs)
{
    for (NSDictionary *subhack in hackData.hacks)
    {
        NSString *name = [subhack objectForKey:kSUBHACKNAME];
        NSArray *patches = [subhack objectForKey:kSUBHACKNAME];
        for(NSDictionary *patchData in patches)
        {
            if(prefs)
            {
                if(![[prefs objectForKey:name] boolValue])
                    continue;
            }
            NSString *type = [patchData objectForKey:kPATCHTYPE];
            NSNumber *address = [patchData objectForKey:kPATCHADDRESS];
            NSNumber *data = [patchData objectForKey:kPATCHDATA];
            
            if([type isEqualToString:kPATCH_8])
            {
                if(!patch<uint8_t>((uint8_t*)[address pointerValue], [data unsignedCharValue]))
                {
                    HACK_ERR();
                }
            }
            else if ([type isEqualToString:kPATCH_16]) 
            {
                if(!patch<uint16_t>((uint16_t*)[address pointerValue], CFSwapInt16([data unsignedShortValue])))
                {
                    HACK_ERR();
                }
            }
            else if ([type isEqualToString:kPATCH_32]) 
            {
                if(!patch<uint32_t>((uint32_t*)[address pointerValue], CFSwapInt32([data unsignedIntValue])))
                {
                    HACK_ERR();
                }
            }
            else if ([type isEqualToString:kPATCH_64]) 
            {
                if(!patch<uint64_t>((uint64_t*)[address pointerValue], CFSwapInt64([data unsignedLongLongValue])))
                {
                    HACK_ERR();
                }
            }
                      
        }
    }
    
}



