#import "hack_parser.h"
#import "JSONKit.h"

@interface hack ()


-(void)_parseNSJSON:(NSString*)filePath;
-(void)_parseJSONKit:(NSString*)filePath;
@end

@implementation hack
@synthesize hackname=_hackname, hackauthor=_hackauthor, targetversion = _targetversion, targetshortversion=_targetshortversion , hacks=_hacks;

-(id)initWithHackFile:(NSString *)hackFilePath
{
    if((self = [super init]))
    {
        double version = [[[UIDevice currentDevice] systemVersion] doubleValue];
        if(version >= 5.0)
        {
            [self _parseNSJSON:hackFilePath];
        }
        else
        {
            [self _parseJSONKit:hackFilePath];
        }
    }
    
    return self;
}

-(void)_parseNSJSON:(NSString *)filePath
{
    NSData *hackData = [NSData dataWithContentsOfFile:filePath];
    NSError *error;
    NSDictionary * json_object = [NSJSONSerialization JSONObjectWithData:hackData options:0 error:&error];
    
    self.hackname = [json_object objectForKey:kHACKNAME];
    self.hackauthor = [json_object objectForKey:kHACKAUTHOR];
    self.targetversion = [json_object objectForKey:kHACKVERSION];
    self.targetshortversion = [json_object objectForKey:kHACKSHORTVERSION];
    self.hacks = [json_object objectForKey:kHACKS];
}

-(void)_parseJSONKit:(NSString *)filePath 
{
    NSData *hackData = [NSData dataWithContentsOfFile:filePath];
    NSError *error;
    NSDictionary* json_object = [[JSONDecoder decoder] objectWithData:hackData error:&error];
    
    self.hackname = [json_object objectForKey:kHACKNAME];
    self.hackauthor = [json_object objectForKey:kHACKAUTHOR];
    self.targetversion = [json_object objectForKey:kHACKVERSION];
    self.targetshortversion = [json_object objectForKey:kHACKSHORTVERSION];
    self.hacks = [json_object objectForKey:kHACKS];
}

-(NSUInteger)hackCount
{
    return (_hacks) ? [_hacks count] : 0;
}

-(NSArray*)hackNames
{
    NSMutableArray *array = [NSMutableArray arrayWithCapacity:[self hackCount]];
    for(NSDictionary *dict in self.hacks)
    {
        [array addObject:[dict objectForKey:kSUBHACKNAME]];
    }
    return [NSArray arrayWithArray:array];
}


-(void)dealloc
{
    self.hackname = nil;
    self.hackauthor = nil;
    self.targetversion = nil;
    self.targetshortversion = nil;
    self.hacks = nil;
    [super dealloc];
}

@end
